Package org.gradle.language.scala.tasks

# Class BaseScalaCompileOptions

java.lang.Object
org.gradle.language.scala.tasks.BaseScalaCompileOptions

All Implemented Interfaces:
  `Serializable`

Direct Known Subclasses:
  `ScalaCompileOptions`

public abstract class BaseScalaCompileOptions extends Object implements Serializable
Options for Scala platform compilation.

See Also:
  - Serialized Form

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `BaseScalaCompileOptions()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `forkOptions(Action<? super ScalaForkOptions> action)`
  Configure options for running the Scala compiler in a separate process.
  `abstract ListProperty<String>`
  `getAdditionalParameters()`
  Additional parameters passed to the compiler.
  `abstract Property<String>`
  `getDebugLevel()`
  Generate debugging information.
  `abstract Property<Boolean>`
  `getDeprecation()`
  Generate deprecation information.
  `abstract Property<String>`
  `getEncoding()`
  Encoding of source files.
  `abstract Property<Boolean>`
  `getFailOnError()`
  Fail the build on compilation errors.
  `abstract Property<Boolean>`
  `getForce()`
  Whether to force the compilation of all files.
  `ScalaForkOptions`
  `getForkOptions()`
  Options for running the Scala compiler in a separate process.
  `IncrementalCompileOptions`
  `getIncrementalOptions()`
  Options for incremental compilation of Scala code.
  `Property<Boolean>`
  `getIsDeprecation()`
  `Property<Boolean>`
  `getIsFailOnError()`
  `Property<Boolean>`
  `getIsForce()`
  `Property<Boolean>`
  `getIsListFiles()`
  `Property<Boolean>`
  `getIsOptimize()`
  `Property<Boolean>`
  `getIsUnchecked()`
  `abstract Property<KeepAliveMode>`
  `getKeepAliveMode()`
  Keeps Scala compiler daemon alive across builds for faster build times
  `abstract Property<Boolean>`
  `getListFiles()`
  List files to be compiled.
  `abstract Property<String>`
  `getLoggingLevel()`
  Specifies the amount of logging.
  `abstract ListProperty<String>`
  `getLoggingPhases()`
  Phases of the compiler to log.
  `protected abstract ObjectFactory`
  `getObjectFactory()`
  `abstract Property<Boolean>`
  `getOptimize()`
  Run optimizations.
  `abstract Property<Boolean>`
  `getUnchecked()`
  Generate unchecked information.
  `void`
  `incrementalOptions(Action<? super IncrementalCompileOptions> action)`
  Configure options for incremental compilation of Scala code.
  `void`
  `setAdditionalParameters(List<String> additionalParameters)`
  Sets the additional parameters.
  `void`
  `setDebugLevel(@Nullable String debugLevel)`
  `void`
  `setDeprecation(boolean deprecation)`
  `void`
  `setEncoding(@Nullable String encoding)`
  `void`
  `setFailOnError(boolean failOnError)`
  `void`
  `setForce(boolean force)`
  `void`
  `setListFiles(boolean listFiles)`
  `void`
  `setLoggingLevel(String loggingLevel)`
  `void`
  `setLoggingPhases(List<String> loggingPhases)`
  `void`
  `setOptimize(boolean optimize)`
  `void`
  `setUnchecked(boolean unchecked)`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### BaseScalaCompileOptions

    @Inject public BaseScalaCompileOptions()

- ## Method Details

  - ### getObjectFactory

    @Inject protected abstract ObjectFactory getObjectFactory()

  - ### getFailOnError

    @Input public abstract Property<Boolean> getFailOnError()
    Fail the build on compilation errors.

  - ### getIsFailOnError

    @Internal public Property<Boolean> getIsFailOnError()

  - ### setFailOnError

    public void setFailOnError(boolean failOnError)

  - ### getDeprecation

    @Console public abstract Property<Boolean> getDeprecation()
    Generate deprecation information.

  - ### getIsDeprecation

    @Internal public Property<Boolean> getIsDeprecation()

  - ### setDeprecation

    public void setDeprecation(boolean deprecation)

  - ### getUnchecked

    @Console public abstract Property<Boolean> getUnchecked()
    Generate unchecked information.

  - ### getIsUnchecked

    @Internal public Property<Boolean> getIsUnchecked()

  - ### setUnchecked

    public void setUnchecked(boolean unchecked)

  - ### getDebugLevel

    @Optional @Input public abstract Property<String> getDebugLevel()
    Generate debugging information. Legal values: none, source, line, vars, notailcalls

  - ### setDebugLevel

    public void setDebugLevel(@Nullable String debugLevel)

  - ### getOptimize

    @Input public abstract Property<Boolean> getOptimize()
    Run optimizations.

  - ### getIsOptimize

    @Internal public Property<Boolean> getIsOptimize()

  - ### setOptimize

    public void setOptimize(boolean optimize)

  - ### getEncoding

    @Optional @Input public abstract Property<String> getEncoding()
    Encoding of source files.

  - ### setEncoding

    public void setEncoding(@Nullable String encoding)

  - ### getForce

    @Input public abstract Property<Boolean> getForce()
    Whether to force the compilation of all files. Legal values: - false (only compile modified files) - true (always recompile all files)

  - ### getIsForce

    @Internal public Property<Boolean> getIsForce()

  - ### setForce

    public void setForce(boolean force)

  - ### getAdditionalParameters

    @Optional @Input public abstract ListProperty<String> getAdditionalParameters()
    Additional parameters passed to the compiler. Each parameter must start with '-'.
    Returns:
      The list of additional parameters.

  - ### setAdditionalParameters

    public void setAdditionalParameters(List<String> additionalParameters)
    Sets the additional parameters.

    Setting this property will clear any previously set additional parameters.

  - ### getListFiles

    @Console public abstract Property<Boolean> getListFiles()
    List files to be compiled.

  - ### getIsListFiles

    @Internal public Property<Boolean> getIsListFiles()

  - ### setListFiles

    public void setListFiles(boolean listFiles)

  - ### getLoggingLevel

    @Console public abstract Property<String> getLoggingLevel()
    Specifies the amount of logging. Legal values: none, verbose, debug

  - ### setLoggingLevel

    public void setLoggingLevel(String loggingLevel)

  - ### getLoggingPhases

    @Console public abstract ListProperty<String> getLoggingPhases()
    Phases of the compiler to log. Legal values: namer, typer, pickler, uncurry, tailcalls, transmatch, explicitouter, erasure, lambdalift, flatten, constructors, mixin, icode, jvm, terminal.

  - ### setLoggingPhases

    public void setLoggingPhases(List<String> loggingPhases)

  - ### getForkOptions

    public ScalaForkOptions getForkOptions()
    Options for running the Scala compiler in a separate process.

  - ### forkOptions

    public void forkOptions(Action<? super ScalaForkOptions> action)
    Configure options for running the Scala compiler in a separate process.
    Since:
      8.11

  - ### getIncrementalOptions

    public IncrementalCompileOptions getIncrementalOptions()
    Options for incremental compilation of Scala code.

  - ### incrementalOptions

    public void incrementalOptions(Action<? super IncrementalCompileOptions> action)
    Configure options for incremental compilation of Scala code.
    Since:
      8.11

  - ### getKeepAliveMode

    @Incubating @Input public abstract Property<KeepAliveMode> getKeepAliveMode()
    Keeps Scala compiler daemon alive across builds for faster build times
    Since:
      7.6